require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Intent"
import "android.content.Context"

local Symbol={}
dir=package.searchpath("main",package.path):match("(.*)main.lua")
local path= dir.."data"

---读取符号文件函数
local function readSymbol(t,path)
	local file,eor=io.open(path,"r")
	if eor~=nil then
		file,eor=io.open(path,"w")
	end
	
	local s
	for line in io.lines(path) do
		s=string.gsub(line,'\\n','\n')
		s= s=="\\\\" and "\\" or s
		table.insert(t,s)
	end
	file:close()
end

---写入符号函数
local function writeSymbol(t,path)
	file=io.open(path,'w')
	for _,v in ipairs(t) do
		v= v=="\\" and "\\\\" or v
		file:write(string.gsub(v,'\n','\\n')..'\n')
	end
	file:close()
end

---移动函数
local function moveItem(t,k,itemKey)
	local s=t[k+1]
if itemKey == 0 then
table.insert(t, 1, s) -- insert s at the beginning of the table
table.remove(t, k + 2) -- remove element at index k + 2
		elseif itemKey==1 then
		table.remove(t,k+1)
	end
end

---编辑框界面
local edit=loadlayout({
	EditText;
	hint="Ви можете ввести символи або текст у декілька рядків!. "
})
local et=LuaDialog()
et.setTitle("Додати")
et.setView(edit)
et.setButton("ok",function()
	if edit.text~='' then
		table.insert(Symbol,edit.text)
		edit.text=''
		writeSymbol(Symbol,path)
	end
	--重新载入符号表
	grid.adapter=SingleLineAdapter(service,String(Symbol))
	dlg.show()
end)

---说明界面
local readme=LuaDialog(service)
readme.setTitle("Опис")
readme.setMessage("Привіт! Це плагін для введення емодзі. У ньому є багато різних емодзі. Якщо ви хочете додати інші емодзі або символи, натисніть кнопку Додати. ")
readme.setButton("Закрити",function()

	dlg.show()
end)

---长按菜单
local menuItem=
{
	"Перемістити на початок",
	"Видалити",
}
local menuDlg=LuaDialog(service)
--menuDlg.setTitle("Меню")
menuDlg.setItems(menuItem)

---主界面
layout={
	GridView,
	id="grid",
	numColumns=6,
	layout_width="fill",
	layout_height="fill"
}

dlg=LuaDialog(service)
dlg.View=loadlayout(layout)
readSymbol(Symbol,path)
grid.adapter=SingleLineAdapter(service,String(Symbol))
dlg.setButton("Закрити")
dlg.setButton2("Додати",function(v)
	task(50,function()
		et.show()
	end)
end)
dlg.setButton3("Опис",function(v)
	readme.show()
end)

dlg.show()
grid.onItemClick=function(l,v)
	dlg.dismiss()
	service.pasteText(node,v.text)
	service.speak(v.text)
	return true
end

grid.onItemLongClick=function(l,v,p,i)
	dlg.dismiss()
	vibrator = this.getSystemService(Context.VIBRATOR_SERVICE)
	vibrator.vibrate( long{50,30} ,-1)
	menuDlg.show()
	menuDlg.onItemClick=function(_,_,itemKey)
		menuDlg.dismiss()
		moveItem(Symbol,i,itemKey)
		writeSymbol(Symbol,path)
		--重新载入符号表
		grid.adapter=SingleLineAdapter(service,String(Symbol))
		dlg.show()
	end

end